//Julia-Menge zu z -> f(z)/g(z)  mit f(z) = z^7-3z^3+cos(z)+c und g(z) = z^6 + sin(z);
//Mit Tasten <1>...<5> wählt man das gewünschte Bild
//1: Julia4 mit Winkeldifferenz-Farbgebung
//2: JuliaMenge Konvergenzbild
//3: Julia mit 9-Kreise Traps
//4: Julia-Menge lokalisieren (weiß auf schwarz)
//O: Orbits zeichnen - vorher Konvergenzbild (2) oder Winkeldifferenzbild (1) berechnen
//Linksklick zoomen an angeklickte Stelle
//Taste <c> wählt einen zufälligen c-Wert.

//Weitere Informationen:  https://ningelgen.eu
/////////////////////////////////////////////////////////////////////////////////////////////////////////
ArrayList<Threads> threads;

Complex zNeu,zAlt,z,z0,z1,C,zA,zB,zfZaehlerNewton,zF;
ArrayList<Complex> fixpunkte;
FarbTafel farben;
double zR,zI;
//double xU = -3; double yU = -3; double xO =  3; double yO =  3; 
double xU = -36; double yU = -36; double xO =  36;double yO =  36;//maxiterations muss in diesem Fall mindestens 50 000 sein!
double zoomFaktor=1;
double wh = xO-xU;
double x0,y0;
double laenge;
double a,b; //Fixpunkte
float aP,bP;//...und ihre Koordinaten
boolean FPzeichnen = false;
boolean farbig = false;//Unterscheidung verschiedener Orbitpunkte
boolean orbitZeichnen = false;
int Selektor;
int maxiterations = 4000;//500 - 50 000;//Iterationsgrenze - dauert einige Minuten!
int anzahlFixpunkte = 20; //...im vorgegebenen Bereich (innerhalb Ursprungskreis mit Radius radiusFixpunkte) - größtmögliche Zahl muss man testen
int maxFPIteration = 500*maxiterations;//Iterationsgrenze beim Suchen der Fixpunkte. Je mehr Fixpunkte desto höher wählen
int anzahlOrbits = 500;//1000
int orbitZeichnenAb ;
int orbitZeichnenBis;
int punktGroesse;
double massFuerUnendlich = 1000; //1e16;
double E = 0.1 ; // Zwei FP gelten als gleich, wenn Realteil und Imaginärteil maximal Abstand E haben (muss man an Iteration anpassen!)
double e = 1-10; //Abstand, ab dem der Orbitpunkt als zugehöriger Fixpunkt gilt
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 
double gW = 60;
color farbe,fpFarbe;//Farbe für Orbits und Fixpunkte


void setup() {
  background(255); 
  colorMode(RGB);
  threads = new  ArrayList<Threads>();   
  fixpunkte = new ArrayList<Complex>();
  farben= new FarbTafel();
  farben.farbTafelErzeugen();  
  size(400, 400);
  //c-Wert
  x0=-0.3; y0=0.5;
  C = new Complex(x0,y0);
  z0 = new Complex(0,0);
  Selektor = 1 ;
  fixPunkteBestimmen();//falls Fixpunkte im Bereich -36 und 36 (für x und y) berechnet werden sollen. Kann einige Minuten dauern...
 
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,
                Selektor, e, fixpunkte); 
}
/////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer, double X0, double Y0, 
                   int selektor, double e,ArrayList<Complex> fixpunkte){
  
  xU = px; yU = py;
  x0 = X0; y0 = Y0;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  Selektor = selektor;
  wh = pwh;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread,x0,y0,
                        selektor, e,fixpunkte);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(200);//zur Verringerung der Pixelfehler 
  }  
}
//////////////////////////////////////////////////////////////
void draw() {
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
       if(t.gibNummer() ==0)println("fertig!");
       noLoop();
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);  
  }  
  
  if(orbitZeichnen){
     
      juliaIteration(z0,orbitZeichnenAb,orbitZeichnenBis );  
      orbitZeichnen = false;
      farbig = false;
  }
  
  if(FPzeichnen){
    println("Fixpunkte eintragen");
    if(fixpunkte.size() ==0){
          fixPunkteBestimmen();
      }
    
    for(int l =0; l<anzahlFixpunkte;l++){
      fixPunktEintragen(fixpunkte.get(l));
    }
    FPzeichnen = false;
  }
  
}
///////////////////////////////////////////////////////////////////////
void fixPunkteBestimmen(){ 
  //Zunächst alle vorhandenen Punkte löschen
  fixpunkte = new ArrayList<Complex>();
  zF = startWertFP();  
  fixpunkte.add(zF);
  println("Fixpunkt 1: "+fixpunkte.get(0));  
  int j =1;
  while(j<anzahlFixpunkte){
    
    while(naeheTestenMit(j)){
      zF = startWertFP();
    }
   
    fixpunkte.add(zF); 
    
    println("Fixpunkt "+(j+1)+": "+fixpunkte.get(j));
    j++;
    //}
  }
}
//////////////////////////////////////////////////////////
Complex startWertFP(){
   zF = new Complex(50,50);
   while(Math.abs(zF.getRealPart())>37 || Math.abs(zF.getImaginaryPart())<6 ){
     zR = random(-37,37); zI = random(-37,37);// je nach zu zeichnendem Bereich können die Fixpunkte auch unsichtbar sein.
     //Für den Julia-Quadrattest werden sie dennoch benötigt.
     zAlt =new Complex(zR,zI); //Startwert
     zF = JuliaIteration(zAlt,maxFPIteration);
  }
 
  return zF; 
}
////////////////////////////////////////////////////////////////
boolean naeheTestenMit(int j){
  
    boolean zuNahTest = false;  
    boolean[] zuNah;
    
    zuNah = new boolean[j];  
    for(int i=0; i<j; i++){
      boolean zuNahReal = Math.abs(zF.getRealPart()-(fixpunkte.get(i)).getRealPart()) < E;
      boolean zuNahImaginary = Math.abs(zF.getImaginaryPart()-(fixpunkte.get(i)).getImaginaryPart()) < E;
      zuNah[i] = zuNahReal  &&  zuNahImaginary;      
      zuNahTest = zuNahTest || zuNah[i];
    }  
    return zuNahTest;
  }
///////////////////////////////////////////////////////////////
void fixPunktEintragen(Complex Z1 ){  
  
  strokeWeight(10); 
  stroke(fpFarbe);
  a = Z1.getRealPart();
  b = Z1.getImaginaryPart();
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
}
//////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z, int M, int N) {//...um einen Orbit zu zeichnen ..ab ..bis
  int n = 0;
  a = Z.getRealPart();
  b = Z.getImaginaryPart(); 
  zAlt = new Complex(a,b);    // println(zAlt);
  if(farbig) {
     colorMode(HSB,255,255,255);
     farbe = color(random(0,255),255,255);
     stroke(farbe);
     
   }else{
      colorMode(RGB, 255,255,255);
      stroke(255);
    }   
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  strokeWeight(punktGroesse+2);
  point(aP,bP);//Startpunkt
  
  while (n < N) {
    a = zAlt.getRealPart();
    b = zAlt.getImaginaryPart();
    if(Math.abs(a) > 100000 || Math.abs(b) > 300) {println("out by "+n);break;}//Kontrolle
    
    zNeu = JuliaIteration(zAlt,1);   
    laenge = zNeu.getLength(); //println("Exakt "+n,zNeu,laenge);
       
    a = zNeu.getRealPart();
    b = zNeu.getImaginaryPart();
    if(orbitZeichnen && n > M-2 ){   
      //if(n<10 || n>N-10)println(n,zNeu);      
      aP = map((float)a,(float)xU,(float)xO,0,width);
      bP = map((float)b,(float)yU,(float)yO,height,0);
      stroke(255);
      strokeWeight(punktGroesse);
      point(aP,bP);
    }
    zAlt = new Complex(a,b);
    n++; 
  }
  colorMode(RGB);
  return n;
 }

////////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
         
      if (mouseButton == LEFT&& keyCode == SHIFT){ //Angeklickte Stelle zoomen
          xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
          xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
          xU = xUNeu; xO = xONeu; 
          yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
          yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
          yU =yUNeu; yO = yONeu; 
          wh = wh/5;
          e = e/2;//epsilon
          zoomFaktor =zoomFaktor*5;
          println("Zoomfaktor: "+zoomFaktor);
          starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, 
                        Selektor,e, fixpunkte);  
          redraw();
        
     }
   if (mouseButton == RIGHT){   
     if (keyPressed == true && keyCode == SHIFT){//Orbit von Beginn an einzeichnen
          orbitZeichnen = true;
          farbig = true;//bei jedem Klick neue Farbe
          orbitZeichnenAb = 1;
          orbitZeichnenBis = 50000;//2000000;
          punktGroesse =1;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          if(fixpunkte.size() >0){println("Anzahl der Fixpunkte "+fixpunkte.size());
            FPzeichnen = true;
            for(int l =0; l<anzahlFixpunkte;l++){
                 fixPunktEintragen(fixpunkte.get(l));
            }
            FPzeichnen = false;
          }
          println("Orbit Punkte zeichnen von Beginn bis "+orbitZeichnenBis);
          redraw();
         
     }else if (keyPressed == false){ //Orbit ab Element orbitZeichnenAb einzeichnen
          orbitZeichnen = true;
          orbitZeichnenAb  = 1;
          orbitZeichnenBis = 50000;
          punktGroesse =1;   
          farbig = false;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen ab n = "+ orbitZeichnenAb);
          redraw();
     }
 }  
}
/////////////////////////////////////////////////////////////////
void keyPressed() {
 
  if (key == 'c'){
      println("Zufälligen C-Wert wählen");
      x0=random(-8,8); y0=random(-8,8);//C-Wert
      C = new Complex(x0,y0);
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,
                    Selektor,e, fixpunkte);
      redraw();
  }
  
   if (key == 'f'){//Fixpunkte einzeichnen (nur sichtbar xU ..xO Bereich)
      fpFarbe = color(255);
      if(fixpunkte.size() ==0){
           fixpunkte = new ArrayList<Complex>();
      }
      println("Fixpunkte im Bereich x "+xU,xO+"  y "+yU,yO);
      FPzeichnen=true;
      redraw();
  }
    
  if (key == '1'){//Fatou-Gebiete farbig einzeichnen
      xU = -36; xO = 36;
      yU = -36; yO = 36;
      wh = xO-xU;
      nummerThread =0;
      println("Fatou-Gebiete farbig einzeichnen");
      Selektor = 1; 
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e, fixpunkte);
      redraw();
  }   
  
  if (key == '2'){//Julia-Menge Konvergenzgeschwindigkeit
      nummerThread =0;
      //xU = -36; xO = 36;
      //yU = -36; yO = 36;
      //wh = xO-xU;
      println("Julia-Menge Konvergenzgeschwindigkeit");
      fpFarbe = color(255);
      Selektor = 2;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e, fixpunkte);
      redraw();
  }  
  
   if (key == '3'){//Fatou-Gebiete farbig einzeichnen und Julia-Menge mit 9-Kreise-Traps
      nummerThread =0;
      println("2Julia Fraktal mit Traps");
      Selektor = 3;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e, fixpunkte);
      redraw();
  }  
  
  if (key == '4'){//Julia-Menge weiß auf schwarzem Hintergrund
      nummerThread =0;
      xU = -2; 
      yU = -2; 
      xO =  2;
      yO =  2;
      println("Julia-Menge weiß auf schwarzem Hintergrund");
      Selektor = 4;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e, fixpunkte);
      redraw();
  }  
  
  if (key == 'O'){//Orbits 
       
        for(int i=0;i<anzahlOrbits;i++){
          
          orbitZeichnen = true;
          farbig = false;//true: bei jedem Klick neue Farbe
          orbitZeichnenAb = 1;
          orbitZeichnenBis = 100000; //20000;
          punktGroesse =1;
          float xH = random((float)xU,(float)xO);
          float yH = random((float)yU,(float)yO);
          z0 = new Complex(xH,yH);
          juliaIteration(z0,orbitZeichnenAb,orbitZeichnenBis);
          println(i);
         
       redraw();
        }
         if(fixpunkte.size() >0){println("Anzahl der Fixpunkte "+fixpunkte.size());
            fpFarbe = color(255);
            FPzeichnen = true;
            for(int l =0; l<anzahlFixpunkte;l++){
                 fixPunktEintragen(fixpunkte.get(l));
            }
            FPzeichnen = false;
          }
           println("Orbit Punkte zeichnen von Beginn bis "+orbitZeichnenBis);
      }
     
  if (key == '+'){//Iterationsgrenze erhöhen
     nummerThread =0;
     maxiterations *= 2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e, fixpunkte);
  }
  if (key == '-') {//Iterationsgrenze veringern
      nummerThread =0;
      maxiterations /= 2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Selektor,e, fixpunkte);  
  }
//Die folgenden Aktionen betreffen zoomen und verschieben des Bildes//////////////////////////////// 
  if (key == 'z'){//zoomen in der Mitte
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e, fixpunkte);
  }
  if (key == 'l'){//Bild nach links verschieben
     nummerThread =0;
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e, fixpunkte);
  }
  if (key == 'r'){//Bild nach rechts verschieben
     nummerThread =0;
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e, fixpunkte);
  }
   if (key == 'u'){//Bild nach unten verschieben
     nummerThread =0;
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e, fixpunkte);
  }
  if (key == 'o'){//bild nach oben verschieben
     nummerThread =0;
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Selektor,e, fixpunkte);
  }
  ///Bild speichern/////////////////////////////////////////////////////////////////////////
  if (key == 's') save("julia.png");
  redraw();
}


//Iterations-Algorithmus////////////////////////////////////////////////////////////////////
  Complex JuliaIteration(Complex zAlt, int M){//Newton-Iteration 
 
   for(int i =0; i< M;i++){
      zNeu = f(zAlt,C).divide(g(zAlt));
      zAlt = zNeu;//println(zAlt);
   }
  return zAlt;
 }
 Complex f(Complex zAlt,Complex C){    //Zähler Newton-Iteration
      
      Complex zaehler = new Complex(0,0);
      zaehler = zAlt.power(7);//z^7
      zaehler = zaehler.addC(C);//z^7+c 
      zaehler = zaehler.subtractC((zAlt.power(3)).multiply(3));//z^7-3z^3+c 
      zaehler = zaehler.addC(zAlt.cosC());//z^7-3z^3+cos(z)+c 
      return zaehler;
 }
 Complex g(Complex zAlt){               //Nenner Newton-Iteration
      Complex nenner = new Complex(0,0);
      nenner = zAlt.power(6);//z^6
      nenner = nenner.addC(zAlt.sinC());//z^6+sin(z)
      if(nenner.getLength() < 0.000000001) nenner = new Complex(0.000001,0.000001);//Nenner 0 vermeiden
      return nenner;
 }
